package o1.movies

import o1.util.readFileLines

////////////////// NOTE TO STUDENTS //////////////////////////
// For the purposes of our course, it’s not necessary
// that you understand or even look at the code in this file.
//////////////////////////////////////////////////////////////

class MovieListFile(val fileName: String):

  val movies =  // this example has naïve error handling: empty result if no such file
    val linesInVector = readFileLines(s"o1/movies/$fileName") getOrElse Vector()
    this.parse(linesInVector)

  private def parse(listItems: Vector[String]): Vector[Movie] =
    val tokenized = listItems.map( _.split(";") )
    tokenized.map( tokens => Movie(tokens(0), tokens(1).toInt, tokens(2).toInt,
                                   tokens(3).toDouble, tokens(4).split(",").toVector) )

  override def toString = this.fileName + " (contains: " + this.movies.size + " movies)"

end MovieListFile

